import { Network } from "./network.entity";
import { TAggregatorProvider, TAggregatorProviders } from "./network.interface";
import { INetworkProviderHealthCheck } from "./network.interface";
import { TypeOrmCrudService } from "@nestjsx/crud-typeorm";
import { DeepPartial, DeleteResult, EntityManager, FindOperator, InsertResult, Repository, UpdateResult } from "typeorm";
export declare class NetworkService extends TypeOrmCrudService<Network> {
    readonly repo: Repository<Network>;
    private _networkWithProviderByChainKey;
    private readonly entity;
    private readonly relations;
    private readonly recursiveRelations;
    constructor(repo: Repository<Network>);
    onModuleInit(): Promise<void>;
    findOneBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<Network>;
    findAllBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<Network[]>;
    createOneBy(params: DeepPartial<Network>, manager?: EntityManager): Promise<Network>;
    createAllBy(params: DeepPartial<Network>[], manager?: EntityManager): Promise<Network[]>;
    createAllIfNotExistBy(params: DeepPartial<Network>[], manager?: EntityManager): Promise<InsertResult>;
    updateOneBy(where: {
        [K in keyof Network]?: any | FindOperator<Network[K]>;
    }, set: {
        [K in keyof Network]?: any;
    }, manager?: EntityManager): Promise<UpdateResult>;
    deleteOneBy(where?: {
        [K in keyof any]?: any[K] | FindOperator<any[K]>;
    }, manager?: EntityManager): Promise<DeleteResult>;
    provider(chainKey: string): TAggregatorProvider;
    providers(chainKey: string): TAggregatorProviders;
    refreshNetwork(network?: Network): Promise<void>;
    multiCallAddress(chainKey: string): string;
    generateNetworkProviders(network: Network): TAggregatorProviders;
    checkProviderHealth(network?: Network): Promise<INetworkProviderHealthCheck>;
}
